﻿Imports System.Threading.Tasks

Public Class Form1
    Private Numbers(3) As Long
    Private Results(3) As Long

    ' Execute the tasks sequentially.
    Private Sub btnSequential_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSequential.Click
        lblResult0.Text = ""
        lblResult1.Text = ""
        lblResult2.Text = ""
        lblResult3.Text = ""
        lblTimeSequential.Text = ""
        Me.Cursor = Cursors.WaitCursor
        Me.Refresh()

        Numbers(0) = CLng(txtNum0.Text)
        Numbers(1) = CLng(txtNum1.Text)
        Numbers(2) = CLng(txtNum2.Text)
        Numbers(3) = CLng(txtNum3.Text)

        Dim start_time As Date = Now

        Fibonacci0()
        lblResult0.Text = Results(0)
        Me.Refresh()

        Fibonacci1()
        lblResult1.Text = Results(1)
        Me.Refresh()

        Fibonacci2()
        lblResult2.Text = Results(2)
        Me.Refresh()

        Fibonacci3()
        lblResult3.Text = Results(3)
        Me.Refresh()

        Dim stop_time As Date = Now
        Dim elapsed As TimeSpan = stop_time.Subtract(start_time)
        lblTimeSequential.Text = elapsed.TotalSeconds.ToString("0.00 sec")
        Me.Cursor = Cursors.Default
    End Sub

    ' Execute the tasks in parallel.
    Private Sub btnParallel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnParallel.Click
        lblResult0.Text = ""
        lblResult1.Text = ""
        lblResult2.Text = ""
        lblResult3.Text = ""
        lblTimeParallel.Text = ""
        Me.Cursor = Cursors.WaitCursor
        Me.Refresh()

        Numbers(0) = CLng(txtNum0.Text)
        Numbers(1) = CLng(txtNum1.Text)
        Numbers(2) = CLng(txtNum2.Text)
        Numbers(3) = CLng(txtNum3.Text)

        Dim start_time As Date = Now

        Parallel.Invoke(
            AddressOf Fibonacci0,
            AddressOf Fibonacci1,
            AddressOf Fibonacci2,
            AddressOf Fibonacci3)

        lblResult0.Text = Results(0)
        lblResult1.Text = Results(1)
        lblResult2.Text = Results(2)
        lblResult3.Text = Results(3)

        Dim stop_time As Date = Now
        Dim elapsed As TimeSpan = stop_time.Subtract(start_time)
        lblTimeParallel.Text = elapsed.TotalSeconds.ToString("0.00 sec")
        Me.Cursor = Cursors.Default
    End Sub

    ' Return the Nth Fibonacci number calculated with recursion.
    Private Function Fibonacci(ByVal N As Long) As Long
        If N <= 1 Then Return 1

        Return Fibonacci(N - 1) + Fibonacci(N - 2)
    End Function

    ' Calculate the Fibonacci number for the
    ' indicated number and save the result.
    Private Sub Fibonacci0()
        Results(0) = Fibonacci(Numbers(0))
    End Sub
    Private Sub Fibonacci1()
        Results(1) = Fibonacci(Numbers(1))
    End Sub
    Private Sub Fibonacci2()
        Results(2) = Fibonacci(Numbers(2))
    End Sub
    Private Sub Fibonacci3()
        Results(3) = Fibonacci(Numbers(3))
    End Sub
End Class
