﻿Imports System.Reflection

Public Class Form1
    Private Sub Form1_Load() Handles MyBase.Load
        ' Make column headers.
        lvwProperties.View = View.Details
        lvwProperties.Columns.Clear()
        lvwProperties.Columns.Add("Property", 10,
            HorizontalAlignment.Left)
        lvwProperties.Columns.Add("Type", 10,
            HorizontalAlignment.Left)
        lvwProperties.Columns.Add("Value", 10,
            HorizontalAlignment.Left)

        ' List the properties.
        ' Use the class you want to study instead of Form1.
        Dim property_value As Object
        Dim properties_info As PropertyInfo() =
            GetType(Form1).GetProperties()
        lvwProperties.Items.Clear()
        For i As Integer = 0 To properties_info.Length - 1
            With properties_info(i)
                If .GetIndexParameters().Length = 0 Then
                    property_value = .GetValue(Me, Nothing)
                    If property_value Is Nothing Then
                        ListViewMakeRow(lvwProperties,
                            .Name,
                            .PropertyType.ToString,
                            "<Nothing>")
                    Else
                        ListViewMakeRow(lvwProperties,
                            .Name,
                            .PropertyType.ToString,
                            property_value.ToString)
                    End If
                Else
                    ListViewMakeRow(lvwProperties,
                        .Name,
                        .PropertyType.ToString,
                        "<array>")
                End If
            End With
        Next i

        ' Size the columns to fit the data.
        lvwProperties.Columns(0).Width = -2
        lvwProperties.Columns(1).Width = -2
        lvwProperties.Columns(2).Width = -2
    End Sub

    ' Helper subroutine ListViewMakeRow makes an item and sub-items in a ListView control.
    ' Make a ListView row.
    Private Sub ListViewMakeRow(ByVal lvw As ListView, ByVal item_title As String, ByVal ParamArray subitem_titles() As String)
        ' Make the item.
        Dim new_item As ListViewItem = lvw.Items.Add(item_title)

        ' Make the sub-items.
        For i As Integer = subitem_titles.GetLowerBound(0) To subitem_titles.GetUpperBound(0)
            new_item.SubItems.Add(subitem_titles(i))
        Next i
    End Sub
End Class
